// plugin_mfrx_log_vote.sma
// Author: mfrx
// Version: 0.10

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#define MAX_OPTIONS 32
#define ACCESS_LVL 2

new STRING_VERSION[MAX_DATA_LENGTH] = "0.10";
new STRING_OPTIONS[MAX_OPTIONS][MAX_TEXT_LENGTH];
new FILENAME[MAX_DATA_LENGTH] = "mfrx_vote_vars.txt";
new iWords = 0;
new MFRX_VOTE_PAUSE = 0;

public plugin_init() 
{
	plugin_registerinfo("Advanced Voting by mfrx", "Allows status reports, voting and vote logging.", STRING_VERSION);

	plugin_registercmd("say", "handleSay", ACCESS_ALL);
	plugin_registercmd("admin_info", "admin_info", ACCESS_ALL, "admin_info: Show current status of various variables including gamemode, time limits and powerups");
	plugin_registercmd("admin_votemap", "admin_votemap", ACCESS_ALL, "admin_votemap: Vote for a map - not available during matches");
	plugin_registercmd("admin_votemode", "admin_votemode", ACCESS_ALL, "admin_votemode: Vote for a gamemode - not available during matches");
	plugin_registercmd("admin_votekick", "admin_votekick", ACCESS_ALL, "admin_votemode: Vote for a gamemode - not available during matches");
	plugin_registercmd("admin_mode", "admin_mode", ACCESS_LVL, "admin_mode: Change gamemode - access level 2 required");
	plugin_registercmd("callvote", "admin_votemode", ACCESS_ALL, "callvote: required for compatability with DMQ");

	//get the words from our file
	new i;
	new sTemp[MAX_TEXT_LENGTH];
	if (fileexists(FILENAME) > 0)
	{
		//new iLines = filesize(FILENAME, lines);
		for (i=0;i<MAX_OPTIONS;i++)
		{
			readfile(FILENAME, sTemp, i, MAX_TEXT_LENGTH);
			if ((strncasecmp("//", sTemp, 2) != 0) && (strncasecmp("", sTemp, 2) != 0))
			{
				STRING_OPTIONS[iWords] = sTemp;
				iWords++;
			}
		}
	}

	return PLUGIN_CONTINUE;
}

preVote()
{
	if (MFRX_VOTE_PAUSE == 1)
	{
		say("should pause");
	}
	return PLUGIN_CONTINUE;
}

postVote()
{
	if (MFRX_VOTE_PAUSE == 1)
	{
		say("should unpause");
	}
	return PLUGIN_CONTINUE;
}

canVoteNow(sUser[])
{
	if (vote_allowed() == 1)
	{
		new sMode[MAX_DATA_LENGTH];
		getstrvar("gamemode", sMode, MAX_DATA_LENGTH);
		new iDead;
		if (strncasecmp(sMode, "1on1", 4) == 0)
		{
			if (countUndead(iDead, sUser) == 2)
			{
				if (iDead == 0)
				{
					return 1;
				}
			}
			else
			{
				return 1;
			}
		}
		else if (strncasecmp(sMode, "2on2", 4) == 0)
		{
			if (countUndead(iDead, sUser) == 4)
			{
				if (iDead == 0)
				{
					return 1;
				}
			}
			else
			{
				return 1;
			}
		}
		else if (strncasecmp(sMode, "3on3", 4) == 0)
		{
			if (countUndead(iDead, sUser) == 6)
			{
				if (iDead == 0)
				{
					return 1;
				}
			}
			else
			{
				return 1;
			}
		}
		else if (strncasecmp(sMode, "4on4", 4) == 0)
		{
			if (countUndead(iDead, sUser) == 8)
			{
				if (iDead == 0)
				{
					return 1;
				}
			}
			else
			{
				return 1;
			}
		}
		else 
		{
			return 1;
		}
	}
	return 0;
}

countUndead(&iDead, sUser[]) 
{
	new SessionID;
	new Team;
	new Dead;
	new WONID;
	new Name[MAX_NAME_LENGTH];
	new iMaxPlayers = maxplayercount();
	new i;
	new sAuthID[MAX_AUTHID_LENGTH];
	new iCount = 0;

	for (i = 1; i <= iMaxPlayers; i++) {
		if(playerinfo(i,Name,MAX_NAME_LENGTH,SessionID,WONID,Team,Dead,sAuthID)==1)
		{
			if (strcasestr(sUser, Name) != -1)
			{
				iDead = Dead;
			}
			if (Dead == 0)
			{
				iCount++;
			}
		}
	}
	return iCount;
}

validMode(sMode[])
{
	new i;
	for (i=0;i<iWords;i++)
	{
		if (strcasestr(sMode, STRING_OPTIONS[i]) != -1) 
		{
			return 1;
		}
	}
	return 0;
}

countBots() 
{
	new SessionID;
	new Team;
	new Dead;
	new WONID;
	new Name[MAX_NAME_LENGTH];
	new iMaxPlayers = maxplayercount();
	new i;
	new sAuthID[MAX_AUTHID_LENGTH];
	new iCount = 0;

	for (i = 1; i <= iMaxPlayers; i++) {
		if(playerinfo(i,Name,MAX_NAME_LENGTH,SessionID,WONID,Team,Dead,sAuthID)==1) {
			if ( streq(sAuthID,"BOT") ) {
				iCount++;
			}
		}
	}
	return iCount;
}

public handleSay(HLCommand, HLData, HLUserName, UserIndex) 
{
	new Speech[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new sText[MAX_TEXT_LENGTH];
	new sUtil[MAX_TEXT_LENGTH];
	
	convert_string(HLData, Speech, MAX_DATA_LENGTH);
	convert_string(HLUserName, User, MAX_NAME_LENGTH);
	strstripquotes(Speech);
	
	if (strncasecmp(Speech, "info", 4) == 0) 
	{
		cmdInfo(User, 0);
	}
	else if (strncasecmp(Speech, "map", 3) == 0)
	{
		strbreak(Speech, sUtil, sText, MAX_TEXT_LENGTH); 
		cmdMap(User, sText, 0);
	}
	else if (strncasecmp(Speech, "votemap", 7) == 0)
	{
		strbreak(Speech, sUtil, sText, MAX_TEXT_LENGTH); 
		cmdVoteMap(User, sText, 0);
	}
	else if (strncasecmp(Speech, "vote_map", 8) == 0)
	{
		strbreak(Speech, sUtil, sText, MAX_TEXT_LENGTH); 
		cmdVoteMap(User, sText, 0);
	}
	else if (strncasecmp(Speech, "vote map", 8) == 0)
	{
		strbreak(Speech, sUtil, sText, MAX_TEXT_LENGTH); 
		strbreak(sText, sUtil, sText, MAX_TEXT_LENGTH); 
		cmdVoteMap(User, sText, 0);
	}
	else if (strncasecmp(Speech, "mode", 4) == 0)
	{
		strbreak(Speech, sUtil, sText, MAX_TEXT_LENGTH); 
		cmdMode(User, sText, 0);
	}
	else if (strncasecmp(Speech, "callvote", 8) == 0)
	{
		strbreak(Speech, sUtil, sText, MAX_TEXT_LENGTH); 
		cmdVoteMode(User, sText, 0);
	}
	else if (strncasecmp(Speech, "votemode", 8) == 0)
	{
		strbreak(Speech, sUtil, sText, MAX_TEXT_LENGTH); 
		cmdVoteMode(User, sText, 0);
	}
	else if (strncasecmp(Speech, "vote_mode", 9) == 0)
	{
		strbreak(Speech, sUtil, sText, MAX_TEXT_LENGTH); 
		cmdVoteMode(User, sText, 0);
	}
	else if (strncasecmp(Speech, "vote mode", 9) == 0)
	{
		strbreak(Speech, sUtil, sText, MAX_TEXT_LENGTH); 
		strbreak(sText, sUtil, sText, MAX_TEXT_LENGTH); 
		cmdVoteMode(User, sText, 0);
	}
	else if (strncasecmp(Speech, "votekick", 8) == 0)
	{
		strbreak(Speech, sUtil, sText, MAX_TEXT_LENGTH); 
		cmdVoteKick(User, sText, 0);
	}
	else if (strncasecmp(Speech, "vote_kick", 9) == 0)
	{
		strbreak(Speech, sUtil, sText, MAX_TEXT_LENGTH); 
		cmdVoteKick(User, sText, 0);
	}
	else if (strncasecmp(Speech, "vote kick", 9) == 0)
	{
		strbreak(Speech, sUtil, sText, MAX_TEXT_LENGTH); 
		strbreak(sText, sUtil, sText, MAX_TEXT_LENGTH); 
		cmdVoteKick(User, sText, 0);
	}
	else if (strncasecmp(Speech, "ready", 5) == 0)
	{
		execclient(User, "ready");
	}
	else if (strncasecmp(Speech, "break", 5) == 0)
	{
		execclient(User, "break");
	}

	return PLUGIN_CONTINUE;
}

public admin_mode(HLCommand, HLData, HLUserName, UserIndex)
{
	new User[MAX_NAME_LENGTH];
	new Data[MAX_DATA_LENGTH];

	convert_string(HLUserName, User, MAX_NAME_LENGTH);
	convert_string(HLData, Data, MAX_NAME_LENGTH);

	cmdMode(User, Data, -1);

	return PLUGIN_CONTINUE;
}

cmdMode(sUser[], sMode[], iConsole)
{
	new sText[MAX_TEXT_LENGTH];
	new iMsg = -1;
	if (access(ACCESS_LVL, sUser))
	{
		if (validMode(sMode))
		{
			iMsg = 0;
			snprintf(sText, MAX_TEXT_LENGTH, "Changing mode to %s", sMode);
			say(sText);
			exec(sMode);
		}
		else
		{
			snprintf(sText, MAX_TEXT_LENGTH, "Sorry %s, %s is not a valid mode on this server", sUser, sMode);
		}
	}
	else
	{
			snprintf(sText, MAX_TEXT_LENGTH, "Sorry %s, you do not have access to that command", sUser);
	}
//inform user of mistake if needed
	if (iMsg == -1)
	{
		if (iConsole == -1)
		{
			messageex(sUser, sText, print_console);
		}
		else
		{
			messageex(sUser, sText, print_chat);
		}
	}
	return PLUGIN_CONTINUE;
}

cmdMap(sUser[], sMap[], iConsole)
{
	new sText[MAX_TEXT_LENGTH];
	new iMsg = -1;
	if (access(ACCESS_LVL, sUser))
	{
		if (valid_map(sMap))
		{
			iMsg = 0;
			snprintf(sText, MAX_TEXT_LENGTH, "Changing map to %s", sMap);
			say(sText);
			changelevel(sMap);
		}
		else
		{
			snprintf(sText, MAX_TEXT_LENGTH, "Sorry %s, %s is not a valid map", sUser, sMap);
		}
	}
	else
	{
			snprintf(sText, MAX_TEXT_LENGTH, "Sorry %s, you do not have access to that command", sUser);
	}
//inform user of mistake if needed
	if (iMsg == -1)
	{
		if (iConsole == -1)
		{
			messageex(sUser, sText, print_console);
		}
		else
		{
			messageex(sUser, sText, print_chat);
		}
	}
	return PLUGIN_CONTINUE;
}

public admin_votekick(HLCommand, HLData, HLUserName, UserIndex)
{
	new User[MAX_NAME_LENGTH];
	new Data[MAX_DATA_LENGTH];

	convert_string(HLUserName, User, MAX_NAME_LENGTH);
	convert_string(HLData, Data, MAX_NAME_LENGTH);

	cmdVoteKick(User, Data, -1);

	return PLUGIN_CONTINUE;
}

cmdVoteKick(sUser[], sMode[], iConsole)
{
	new sText[MAX_TEXT_LENGTH];
	new iMsg = -1;
	if (canVoteNow(sUser) == 1)
	{
		if (check_user(sMode))
		{
			preVote();
			snprintf(sText, MAX_TEXT_LENGTH, "Kick %s?", sMode);
			vote(sText, "Yes", "No", "handleVoteKick", sMode);
			iMsg = 0;
		}
		else
		{
			snprintf(sText, MAX_TEXT_LENGTH, "Sorry %s, %s is not a valid player", sUser, sMode);
		}
	}
	else
	{
		snprintf(sText, MAX_TEXT_LENGTH, "Sorry %s, voting is not available at this time", sUser, sMode);
	}

//inform user of mistake if needed
	if (iMsg == -1)
	{
		if (iConsole == -1)
		{
			messageex(sUser, sText, print_console);
		}
		else
		{
			messageex(sUser, sText, print_chat);
		}
	}
	
	return PLUGIN_CONTINUE;
}

public handleVoteKick(WinningOption, HLParam, VoteCount, UserCount)
{
	new sMode[MAX_TEXT_LENGTH];
	convert_string(HLParam, sMode, MAX_TEXT_LENGTH);

	if (WinningOption == 1)
	{
		new ratio = getvar("kick_ratio");
		if ( VoteCount > (ratio * ((UserCount - countBots()) / 100)))
		{
			new sText[MAX_TEXT_LENGTH];
			snprintf(sText, MAX_TEXT_LENGTH, "Kicking %s due to vote", sMode);
			say(sText);
			kick(sMode);
		}
		else
		{
			say("Not enough votes for kick");
		}
	}
	else
	{
		say("Not enough votes for kick");
	}
	postVote();
	return PLUGIN_CONTINUE;
}

public admin_votemode(HLCommand, HLData, HLUserName, UserIndex)
{
	new User[MAX_NAME_LENGTH];
	new Data[MAX_DATA_LENGTH];

	convert_string(HLUserName, User, MAX_NAME_LENGTH);
	convert_string(HLData, Data, MAX_NAME_LENGTH);

	cmdVoteMode(User, Data, -1);

	return PLUGIN_CONTINUE;
}

cmdVoteMode(sUser[], sMode[], iConsole)
{
	new sText[MAX_TEXT_LENGTH];
	new iMsg = -1;
	if (canVoteNow(sUser) == 1)
	{
		if (validMode(sMode))
		{
			preVote();
			snprintf(sText, MAX_TEXT_LENGTH, "Change mode to %s?", sMode);
			vote(sText, "Yes", "No", "handleVoteMode", sMode);
			iMsg = 0;
		}
		else
		{
			snprintf(sText, MAX_TEXT_LENGTH, "Sorry %s, %s is not a valid mode on this server", sUser, sMode);
		}
	}
	else
	{
		snprintf(sText, MAX_TEXT_LENGTH, "Sorry %s, voting is not available at this time", sUser, sMode);
	}

//inform user of mistake if needed
	if (iMsg == -1)
	{
		if (iConsole == -1)
		{
			messageex(sUser, sText, print_console);
		}
		else
		{
			messageex(sUser, sText, print_chat);
		}
	}
	
	return PLUGIN_CONTINUE;
}

public handleVoteMode(WinningOption, HLParam, VoteCount, UserCount)
{
	new sMode[MAX_TEXT_LENGTH];
	convert_string(HLParam, sMode, MAX_TEXT_LENGTH);

	if (WinningOption == 1)
	{
		new ratio = getvar("map_ratio");
		if ( VoteCount > (ratio * ((UserCount - countBots()) / 100)))
		{
			new sText[MAX_TEXT_LENGTH];
			snprintf(sText, MAX_TEXT_LENGTH, "Changing to %s due to vote", sMode);
			say(sText);
			exec(sMode);
		}
		else
		{
			say("Not enough votes for mode change");
		}
	}
	else
	{
		say("Not enough votes for mode change");
	}
	postVote();
	return PLUGIN_CONTINUE;
}

public admin_votemap(HLCommand, HLData, HLUserName, UserIndex)
{
	new User[MAX_NAME_LENGTH];
	new Data[MAX_DATA_LENGTH];

	convert_string(HLUserName, User, MAX_NAME_LENGTH);
	convert_string(HLData, Data, MAX_NAME_LENGTH);

	cmdVoteMap(User, Data, -1);

	return PLUGIN_CONTINUE;
}

cmdVoteMap(sUser[], sMap[], iConsole)
{
	new sText[MAX_TEXT_LENGTH];
	new iMsg = -1;
	if (canVoteNow(sUser) == 1)
	{
		if (valid_map(sMap))
		{
			preVote();
			snprintf(sText, MAX_TEXT_LENGTH, "Change map to %s?", sMap);
			vote(sText, "Yes", "No", "handleVoteMap", sMap);
			iMsg = 0;
		}
		else
		{
			snprintf(sText, MAX_TEXT_LENGTH, "Sorry %s, %s is not a valid map", sUser, sMap);
		}
	}
	else
	{
		snprintf(sText, MAX_TEXT_LENGTH, "Sorry %s, voting is not available at this time", sUser, sMap);
	}

//inform user of mistake if needed
	if (iMsg == -1)
	{
		if (iConsole == -1)
		{
			messageex(sUser, sText, print_console);
		}
		else
		{
			messageex(sUser, sText, print_chat);
		}
	}
	
	return PLUGIN_CONTINUE;
}

public handleVoteMap(WinningOption, HLParam, VoteCount, UserCount)
{
	new sMap[MAX_TEXT_LENGTH];
	convert_string(HLParam, sMap, MAX_TEXT_LENGTH);

	if (WinningOption == 1)
	{
		new ratio = getvar("map_ratio");
		//say(numtostr(ratio));
		if ( VoteCount > (ratio * ((UserCount - countBots()) / 100)))
		{
			new sText[MAX_TEXT_LENGTH];
			snprintf(sText, MAX_TEXT_LENGTH, "Changing to %s due to vote", sMap);
			say(sText);
			changelevel(sMap);
		}
		else
		{
			say("Not enough votes for map change");
		}
	}
	else
	{
		say("Not enough votes for map change");
	}
	postVote();
	return PLUGIN_CONTINUE;
}

public admin_info(HLCommand, HLData, HLUserName, UserIndex)
{
	new User[MAX_NAME_LENGTH];
	convert_string(HLUserName, User, MAX_NAME_LENGTH);
	cmdInfo(User, -1);
	return PLUGIN_CONTINUE;
}
cmdInfo(sUser[], iConsole)
{
	new sText[MAX_TEXT_LENGTH];
	new sMode[MAX_TEXT_LENGTH];

	getstrvar( "gamemode", sMode, MAX_TEXT_LENGTH );

//what is the gamemode
	snprintf(sText, MAX_TEXT_LENGTH, "Gamemode is: %s", sMode);
	if (iConsole == -1)
	{
		messageex(sUser, sText, print_console);
	}
	else
	{
		messageex(sUser, sText, print_chat);
	}

//map time, round time and kill limit
	if (strcasestr(sMode, "1on1") != -1) 
	{
		snprintf(sText, MAX_TEXT_LENGTH, "Roundtime is %d minutes", getvar("roundtime"));
		if (getvar("outclassed") == 1)
		{
			strcat(sText, " and outclassed is on (the match will end if there is a difference of 15 kills).", MAX_TEXT_LENGTH);
		}
		else
		{
			strcat(sText, " and outclassed is off.", MAX_TEXT_LENGTH);
		}
	}
	else if (strcasestr(sMode, "on") != -1) 
	{
		snprintf(sText, MAX_TEXT_LENGTH, "Roundtime is %d minutes", getvar("roundtime"));
	}
	else
	{
		new iFrag = getvar("mp_fraglimit");
		new iTime = getvar("mp_timelimit");
		new iRound = getvar("roundtime");
		if ((iFrag > 0) && (iTime > 0))
		{
			if (iRound > 0)
			{
				snprintf(sText, MAX_TEXT_LENGTH, "Timelimit is %d minutes, round time is %d minutes and there is a limit of %d frags", iTime, iRound, iFrag);
			}
			else
			{
				snprintf(sText, MAX_TEXT_LENGTH, "Timelimit is %d minutes and there is a limit of %d frags", iTime, iFrag);
			}
		}
		else if ((iFrag == 0) && (iTime > 0))
		{
			if (iRound > 0)
			{
				snprintf(sText, MAX_TEXT_LENGTH, "Timelimit is %d minutes, round time is %d minutes and there is no frag limit", iTime, iRound);
			}
			else
			{
				snprintf(sText, MAX_TEXT_LENGTH, "Timelimit is %d minutes and there is no frag limit", iTime);
			}
		}
		else if ((iFrag > 0) && (iTime == 0))
		{
			if (iRound > 0)
			{
				snprintf(sText, MAX_TEXT_LENGTH, "No Timelimit, round time is %d minutes, limit of %d frags", iRound, iFrag);
			}
			else
			{
				snprintf(sText, MAX_TEXT_LENGTH, "No Timelimit, limit of %d frags", iFrag);
			}
		}
	}
	if (iConsole == -1)
	{
		messageex(sUser, sText, print_console);
	}
	else
	{
		messageex(sUser, sText, print_chat);
	}
	
//powerups
	new iQuad = getvar("banpowerup_quad");
	new iPent = getvar("banpowerup_666");
	if ((iQuad == 1) && (iPent == 1))
	{
		strcpy(sText, "Quad damage and Pentagon of Protection are both disabled", MAX_TEXT_LENGTH);
	}
	else if ((iQuad == 0) && (iPent == 1))
	{
		strcpy(sText, "Quad damage is enabled, Pentagon of Protection is disabled", MAX_TEXT_LENGTH);
	}
	else if ((iQuad == 1) && (iPent == 0))
	{
		strcpy(sText, "Quad damage is disabled, Pentagon of Protection is enabled", MAX_TEXT_LENGTH);
	}
	else
	{
		strcpy(sText, "Quad damage and Pentagon of Protection are both enabled - woohoo Quad+Pent fun :D", MAX_TEXT_LENGTH);
	}
	if (iConsole == -1)
	{
		messageex(sUser, sText, print_console);
	}
	else
	{
		messageex(sUser, sText, print_chat);
	}

//misc setings
	new iTeam = getvar("mp_teamplay");
	new iFF = getvar("mp_friendlyfire");
	new iHook = getvar("disable_grapple");
	new iTele = getvar("fasttps");
	new iSpeed = getvar("sv_maxspeed");
	new sSpeed[MAX_TEXT_LENGTH];
	snprintf(sSpeed, MAX_TEXT_LENGTH, " Speed is %d.", iSpeed);

	if (iTeam == 1)
	{
		strcpy(sText, "Teamplay is enabled", MAX_TEXT_LENGTH);
		if (iFF == 1)
		{
			strcat(sText, " and friendly fire is on.", MAX_TEXT_LENGTH);
		}
		else
		{
			strcat(sText, " and friendly fire is off.", MAX_TEXT_LENGTH);
		}
	}
	else
	{
		strcpy(sText, "Teamplay is disabled.", MAX_TEXT_LENGTH);
	}
	if (iHook == 1)
	{
		strcat(sText, " Hook is on.", MAX_TEXT_LENGTH);
	}
	else
	{
		strcat(sText, " Hook is off.", MAX_TEXT_LENGTH);
	}
	if (iTele == 1)
	{
		strcat(sText, " Fast teleports are on.", MAX_TEXT_LENGTH);
	}
	else
	{
		strcat(sText, " Fast teleports are off.", MAX_TEXT_LENGTH);
	}	
	strcat(sText, sSpeed, MAX_TEXT_LENGTH);
	if (iConsole == -1)
	{
		messageex(sUser, sText, print_console);
	}
	else
	{
		messageex(sUser, sText, print_chat);
	}
	return PLUGIN_CONTINUE;
}

